"""
To install:

    python setup.py install
"""
from pathlib import Path
from setuptools import setup


setup(
    name='boxfactory',
    description=(
        "Create Python packages just like you* like them, without the hassle."
    ),
    long_description=(Path(__file__).parent / 'README.md').read_text('utf-8'),
    version='0.2.0',
    author='bcj',
    author_email='brendan@bcjbcj.ca',
    url='https://github.com/bcj/boxfactory',
    license=None,
    packages=(
        'boxfactory',
    ),
    entry_points={
        'console_scripts': (
            'boxfactory = boxfactory.cli:main',
        )
    },
    tests_require=(
        'converge',
        'nose',
    ),
    classifiers=(
        "Development Status :: 4 - Beta",
        "Intended Audience :: Developers",
        "Environment :: Console",
        "Programming Language :: Python :: 3",
        "Programming Language :: Python :: 3.6",
        "Programming Language :: Python :: 3 :: Only",
        "Topic :: Software Development",
        "Topic :: Utilities",
    ),
)
